VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.UserControl ScrollFrame 
   ClientHeight    =   732
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1344
   ControlContainer=   -1  'True
   ScaleHeight     =   732
   ScaleWidth      =   1344
   ToolboxBitmap   =   "ScrollFrame.ctx":0000
   Begin VB.PictureBox picAngle 
      Height          =   132
      Left            =   840
      ScaleHeight     =   84
      ScaleWidth      =   324
      TabIndex        =   2
      Top             =   480
      Visible         =   0   'False
      Width           =   372
   End
   Begin MSComCtl2.FlatScrollBar GScrollBar 
      Height          =   132
      Left            =   0
      TabIndex        =   0
      Top             =   360
      Visible         =   0   'False
      Width           =   492
      _ExtentX        =   868
      _ExtentY        =   233
      _Version        =   393216
      Appearance      =   0
      Arrows          =   65536
      LargeChange     =   300
      Orientation     =   1179649
      SmallChange     =   30
   End
   Begin MSComCtl2.FlatScrollBar VScrollBar 
      Height          =   492
      Left            =   240
      TabIndex        =   1
      Top             =   0
      Visible         =   0   'False
      Width           =   132
      _ExtentX        =   233
      _ExtentY        =   868
      _Version        =   393216
      Appearance      =   0
      LargeChange     =   300
      Orientation     =   1179648
      SmallChange     =   30
   End
End
Attribute VB_Name = "ScrollFrame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private bVBarView As Boolean
Private bGBarView As Boolean
Private deltaTop As Integer
Private deltaLeft As Integer
Private WithEvents frm As Form
Attribute frm.VB_VarHelpID = -1
'Default Property Values:
Const m_def_atFullForm = False
'Property Variables:
Dim m_atFullForm As Boolean




Private Sub frm_Resize()
    SetAligment
End Sub

Private Sub GScrollBar_Change()
    If Ambient.UserMode Then
        Dim ctl As Control
        For Each ctl In UserControl.ContainedControls
            ctl.Left = ctl.Left + deltaLeft - GScrollBar.Value
        Next ctl
        deltaLeft = GScrollBar.Value
    End If
End Sub


Private Sub UserControl_Paint()
    If Ambient.UserMode Then
        GScrollBar.ZOrder
        VScrollBar.ZOrder
        ShowPicAngle
    End If
End Sub

Private Sub UserControl_Resize()
    If Ambient.UserMode Then
        SetSBView
        SetSBSize
        VScrollBar.Value = deltaTop
        GScrollBar.Value = deltaLeft
        deltaTop = 0
        deltaLeft = 0
    End If
End Sub
Private Function SetSBView()
    bVBarView = False
    bGBarView = False
    Dim ctl As Control
    Dim LeftLim As Integer, RightLim As Integer
    Dim TopLim As Integer, BottomLim As Integer
    For Each ctl In UserControl.ContainedControls
        'Debug.Print ctl.Name
        If ctl.Left + ctl.Width + VScrollBar.Width + myBorderWidth > Width Or ctl.Left < 0 Then
            bGBarView = True
        End If
        If ctl.Top + ctl.Height + GScrollBar.Height + myBorderWidth > Height Or ctl.Top < 0 Then
            bVBarView = True
        End If
        
        If ctl.Left < LeftLim Then LeftLim = ctl.Left
        If ctl.Top < TopLim Then TopLim = ctl.Top
        If (ctl.Left + ctl.Width + VScrollBar.Width + myBorderWidth) - Width > RightLim Then RightLim = ctl.Left + ctl.Width + VScrollBar.Width + myBorderWidth - Width
        If (ctl.Top + ctl.Height + GScrollBar.Height + myBorderWidth) - Height > BottomLim Then BottomLim = ctl.Top + ctl.Height + GScrollBar.Height + myBorderWidth - Height
    Next ctl
    VScrollBar.Visible = bVBarView
    GScrollBar.Visible = bGBarView
    If bVBarView Then
        VScrollBar.Min = TopLim
        VScrollBar.Max = BottomLim
    End If
    If bGBarView Then
        GScrollBar.Min = LeftLim
        GScrollBar.Max = RightLim
    End If
End Function
Private Function SetSBSize()
    VScrollBar.Top = 0
    VScrollBar.Left = Width - VScrollBar.Width - myBorderWidth
    If bGBarView Then
        VScrollBar.Height = IIf(Height - GScrollBar.Height - myBorderWidth <= 0, Height, Height - GScrollBar.Height - myBorderWidth)
    Else
        VScrollBar.Height = Height
    End If
    
    GScrollBar.Left = 0
    
    GScrollBar.Top = Height - GScrollBar.Height - myBorderWidth
    If bVBarView Then
        GScrollBar.Width = IIf(Width - VScrollBar.Width - myBorderWidth <= 0, Width, Width - VScrollBar.Width - myBorderWidth)
    Else
        GScrollBar.Width = Width
    End If
End Function

Private Sub UserControl_Show()
    If Ambient.UserMode Then
        SetSBView
        SetSBSize
    End If
End Sub

Private Sub VScrollBar_Change()
    If Ambient.UserMode Then
        Dim ctl As Control
        For Each ctl In UserControl.ContainedControls
            ctl.Top = ctl.Top + deltaTop - VScrollBar.Value
        Next ctl
        deltaTop = VScrollBar.Value
    '    SetSBView
        
    End If
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Appearance
Public Property Get Appearance() As AppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = UserControl.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As AppearanceConstants)
    UserControl.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As MSComCtl2.BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As MSComCtl2.BorderStyleConstants)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,FillStyle
Public Property Get FillStyle() As FillStyleConstants
Attribute FillStyle.VB_Description = "Returns/sets the fill style of a shape."
    FillStyle = UserControl.FillStyle
End Property

Public Property Let FillStyle(ByVal New_FillStyle As FillStyleConstants)
    UserControl.FillStyle() = New_FillStyle
    PropertyChanged "FillStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,FillColor
Public Property Get FillColor() As OLE_COLOR
Attribute FillColor.VB_Description = "Returns/sets the color used to fill in shapes, circles, and boxes."
    FillColor = UserControl.FillColor
End Property

Public Property Let FillColor(ByVal New_FillColor As OLE_COLOR)
    UserControl.FillColor() = New_FillColor
    PropertyChanged "FillColor"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.Appearance = PropBag.ReadProperty("Appearance", AppearanceConstants.cc23D)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", MSComCtl2.BorderStyleConstants.cc2None)
    UserControl.FillStyle = PropBag.ReadProperty("FillStyle", FillStyleConstants.vbFSSolid)
    UserControl.FillColor = PropBag.ReadProperty("FillColor", &H0&)
    If Ambient.UserMode Then
        Set frm = UserControl.Parent
    End If
   
    m_atFullForm = PropBag.ReadProperty("atFullForm", m_def_atFullForm)
    GScrollBar.Height = PropBag.ReadProperty("SBHeight", 132)
    VScrollBar.Width = PropBag.ReadProperty("SBWidth", 132)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Appearance", UserControl.Appearance, AppearanceConstants.cc23D)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, MSComCtl2.BorderStyleConstants.cc2None)
    Call PropBag.WriteProperty("FillStyle", UserControl.FillStyle, FillStyleConstants.vbFSSolid)
    Call PropBag.WriteProperty("FillColor", UserControl.FillColor, &H0&)
    Call PropBag.WriteProperty("atFullForm", m_atFullForm, m_def_atFullForm)
    Call PropBag.WriteProperty("SBHeight", GScrollBar.Height, 132)
    Call PropBag.WriteProperty("SBWidth", VScrollBar.Width, 132)
End Sub
Private Sub ShowPicAngle()
        If VScrollBar.Visible And GScrollBar.Visible Then
            picAngle.Left = VScrollBar.Left
            picAngle.Width = VScrollBar.Width + myBorderWidth
            picAngle.Top = GScrollBar.Top
            picAngle.Height = GScrollBar.Height + myBorderWidth
            picAngle.Visible = True
            picAngle.ZOrder
        Else
            picAngle.Visible = False
        End If
End Sub
Private Sub SetAligment()
    If UserControl.Parent Is UserControl.Extender.Container And atFullForm Then
        '          
        '       
        Dim wid As Single, hgt As Single, border_width As Single, title_height As Single
        border_width = (UserControl.Parent.Width - UserControl.Parent.ScaleWidth) / 2
        title_height = UserControl.Parent.Height - border_width - UserControl.Parent.ScaleHeight
        If UserControl.Extender.Top <> 0 Then UserControl.Extender.Top = 0
        If UserControl.Extender.Left <> 0 Then UserControl.Extender.Left = 0
        If UserControl.Extender.Width <> UserControl.Parent.Width - 2 * border_width Then UserControl.Extender.Width = UserControl.Parent.Width - 2 * border_width
        If UserControl.Extender.Width <> UserControl.Parent.ScaleWidth Then UserControl.Extender.Width = UserControl.Parent.ScaleWidth
        If UserControl.Extender.Height <> UserControl.Parent.Height - title_height Then UserControl.Extender.Height = UserControl.Parent.Height - title_height
        If UserControl.Extender.Height <> UserControl.Parent.ScaleHeight Then UserControl.Extender.Height = UserControl.Parent.ScaleHeight
        ShowPicAngle
    End If
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,1,0,false
Public Property Get atFullForm() As Boolean
    atFullForm = m_atFullForm
End Property

Public Property Let atFullForm(ByVal New_atFullForm As Boolean)
    If Ambient.UserMode Then Err.Raise 382
    m_atFullForm = New_atFullForm
    PropertyChanged "atFullForm"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_atFullForm = m_def_atFullForm
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=GScrollBar,GScrollBar,-1,Height
Public Property Get SBHeight() As Long
Attribute SBHeight.VB_Description = "Returns/sets the current position of the scroll bar."
    SBHeight = GScrollBar.Height
End Property

Public Property Let SBHeight(ByVal New_SBHeight As Long)
    GScrollBar.Height() = New_SBHeight
    PropertyChanged "SBHeight"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=VScrollBar,VScrollBar,-1,Width
Public Property Get SBWidth() As Long
Attribute SBWidth.VB_Description = "Returns/sets the current position of the scroll bar."
    SBWidth = VScrollBar.Width
End Property

Public Property Let SBWidth(ByVal New_SBWidth As Long)
    VScrollBar.Width() = New_SBWidth
    PropertyChanged "SBWidth"
End Property

Public Sub About()
Attribute About.VB_UserMemId = -552
    frmAbout.Show vbModal
End Sub

Private Function myBorderWidth()
    If Ambient.UserMode Then
        If Me.BorderStyle = cc2FixedSingle Then
            If Me.Appearance = cc23D Then
                myBorderWidth = 50
            Else
                myBorderWidth = 25
            End If
        Else
            myBorderWidth = 0
        End If
    End If
End Function
